$ ->
  return unless (form=$('.location-search-form')).is('*')
  $(document).ready ->
    states = new Bloodhound
      datumTokenizer: Bloodhound.tokenizers.obj.whitespace('name')
      queryTokenizer: Bloodhound.tokenizers.whitespace
      prefetch: '/zip_search/location_search.json?by=state&a=1'
    cities = new Bloodhound
      datumTokenizer: Bloodhound.tokenizers.obj.whitespace('name')
      queryTokenizer: Bloodhound.tokenizers.whitespace
      remote:
        url: '/zip_search/location_search.json?by=city&q=%QUERY'
        wildcard: '%QUERY'
    counties = new Bloodhound
      datumTokenizer: Bloodhound.tokenizers.obj.whitespace('name')
      queryTokenizer: Bloodhound.tokenizers.whitespace
      remote:
        url: '/zip_search/location_search.json?by=county&q=%QUERY'
        wildcard: '%QUERY'
    zips = new Bloodhound
      datumTokenizer: Bloodhound.tokenizers.obj.whitespace('name')
      queryTokenizer: Bloodhound.tokenizers.whitespace
      remote:
        url: '/zip_search/location_search.json?by=zip&q=%QUERY'
        wildcard: '%QUERY'
    data_defaults =
      display: 'name'
      templates:
        empty:  '<span></span>'
        suggestion: (datum)->
          output =  "<p style='line-height:16px;padding:5px 20px'>#{datum.name}"
          output += "<br /><small>#{datum.desc}</small>" if datum.desc?
          output += '</p>'
    datasets = [
      $.extend({}, data_defaults, name: 'zips',     source: zips),
      $.extend({}, data_defaults, name: 'counties', source: counties),
      $.extend({}, data_defaults, name: 'cities',   source: cities),
      $.extend({}, data_defaults, name: 'states',   source: states) ]
    $('.zipsearch-typeahead').typeahead null, datasets
    $('.zipsearch-typeahead').on 'typeahead:selected', (e, datum, name)=>
      e.preventDefault()
      console.log datum
      ulid_attrs = type: 'hidden', name: 'ulid'
      by_attrs = type: 'hidden', name: 'by'
      form.prepend $('<input />').attr(ulid_attrs).val(datum.id)
      form.prepend $('<input />').attr(by_attrs).val(datum.param)
      form.submit()

$ ->
  return unless $('.zs-location-fields').is('*')
  $(document).ready ->
    $('.zs-location-fields').each ->
      zip_field = $(@).find('input[name*=zip]')
      county_field = $(@).find('input[name*=county]')
      city_field = $(@).find('input[name*=city]')
      state_field = $(@).find('select[name*=state]')
      zip_field.inputmask
        mask: '99999[-9999]'
        greedy: false
        oncomplete: ->
          v = zip_field.val()
          $.post '/zip_search/zipcode_search', {q: v}, (data)->
            console.log data
            if data.status == 'ok'
              county_field.val(data.county) if data.county?
              city_field.val(data.city) if data.city?
              state_field.find('option').filter(-> $(@).text()==data.state )
                         .prop('selected', true) if data.state?

