require 'zip_search'

module ZipSearch
  module SimpleFormHelper
    METHODS_TO_EXPORT = ZipSearch::ASSOCIATION_MODES.map{|m| :"simple_fields_for_#{m}" }

    def self.simple_fields_for_location(fb, title=:location, *args, &block)
      wrap_zs_fields fb.simple_fields_for(title, *args, &block)
    end
    def self.simple_fields_for_locations(fb, title=:locations, *args, &block)
      wrap_zs_fields fb.simple_fields_for(title, *args, &block)
    end
    def self.simple_fields_for_current_location(fb, title=:current_location, *args, &block)
      wrap_zs_fields fb.simple_fields_for(title, *args, &block)
    end
    def self.simple_fields_for_location_history(fb, title=:location_history, *args, &block)
      wrap_zs_fields fb.simple_fields_for(title, *args, &block)
    end

    def simple_fields_for_location(*args, &block)
      new_block = block_given? ? block : ->(fb2) {
        render partial: 'zip_search/simple_fields',
               locals: { title: :location, f: fb2 } }
      SimpleFormHelper.simple_fields_for_location(*args, &new_block)
    end
    def simple_fields_for_locations(*args, &block)
      new_block = block_given? ? block : ->(fb2) {
        render partial: 'zip_search/simple_fields',
               locals: { title: :locations, f: fb2 } }
      SimpleFormHelper.simple_fields_for_locations(*args, &new_block)
    end
    def simple_fields_for_current_location(*args, &block)
      new_block = block_given? ? block : ->(fb2) {
        render partial: 'zip_search/simple_fields',
               locals: { title: :current_location, f: fb2 } }
      SimpleFormHelper.simple_fields_for_current_location(*args, &new_block)
    end
    def simple_fields_for_location_history(*args, &block)
      new_block = block_given? ? block : ->(fb2) {
        render partial: 'zip_search/simple_fields',
               locals: { title: :location, f: fb2 } }
      SimpleFormHelper.simple_fields_for_location_history(*args, &new_block)
    end

    def self.wrap_zs_fields(fields_content)
      "<div class='zs-location-fields'>#{fields_content}</div>".html_safe
    end

  end
end
